var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useCallback, useEffect, useMemo } from "react";
import { DynamicLevelLocationSelector as CountryRegionSelector } from "country-region-selector";
import { get, isEmpty, pick } from "lodash";
import { getStyleForSettings } from "../../utils/style.util";
import { checkValidFormObjectData } from "../../utils/form-object.util";
import { getDefaultView } from "../../utils/others.util";
import styles from "./address.styles.scss";
export function BSFormObjectAddress(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? getDefaultView() : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var customFields = useMemo(function () {
    return get(object, ["settings", "addressMore", "customFields"]) || {};
  }, [get(object, ["settings", "addressMore", "customFields"])]);

  var _useState = useState(get(object, "type")),
      type = _useState[0];

  var _useState2 = useState(function () {
    var _addressValue;

    if (get(object, ["settings", "addressMore", "default"])) {
      return get(object, ["settings", "addressMore", "default"]);
    }

    var addressValue = (_addressValue = {}, _addressValue[customFields.addressDetail] = null, _addressValue);
    (get(customFields, ["addressLevels"]) || []).forEach(function (cf) {
      return addressValue[cf] = null;
    });
    return addressValue;
  }),
      address = _useState2[0],
      setAddress = _useState2[1];

  var valid = useMemo(function () {
    return checkValidFormObjectData(type)(address, object);
  }, [object, get(object, ["settings", "addressMore", "required"]), address]);

  var _useState3 = useState("vertical"),
      customLayout = _useState3[0];

  var settings = get(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var onChangeAddress = function onChangeAddress(data) {
    setAddress(function (previous) {
      var newAddress = _extends({}, previous);

      (get(customFields, ["addressLevels"]) || []).forEach(function (cf, index) {
        newAddress[cf] = data.value[index] || null;
      });
      return newAddress;
    });
  };

  var onChangeAddressDetail = function onChangeAddressDetail(e) {
    var detail = e.target.value;
    setAddress(function (previous) {
      var _extends2;

      var newAddress = _extends({}, previous, (_extends2 = {}, _extends2[customFields.addressDetail] = detail, _extends2));

      return newAddress;
    });
  };

  useEffect(function () {
    if (!isEmpty(customFields.addressDetail) && !isEmpty(customFields.addressLevels) && onObjectData) {
      var _addressToSend;

      var addressToSend = (_addressToSend = {}, _addressToSend[customFields.addressDetail] = address[customFields.addressDetail], _addressToSend);

      for (var _iterator = _createForOfIteratorHelperLoose(customFields.addressLevels), _step; !(_step = _iterator()).done;) {
        var cf = _step.value;
        addressToSend[cf] = get(address[cf], "name") || null;
      }

      onObjectData(addressToSend);
    }
  }, [address]);
  useEffect(function () {
    !isEmpty(customFields.addressDetail) && !isEmpty(customFields.addressLevels) && onValidData && onValidData(_extends({}, valid || {}));
  }, [valid]);

  var addressLevelSelectorStyle = _extends({}, getStyleForSettings["styleGroups"](get(settings, "addressLevelSelector"), view));

  var addressLevelLabelStyle = _extends({}, getStyleForSettings["styleGroups"](get(settings, "addressLevelLabel"), view));

  var addressDetailStyle = _extends({}, getStyleForSettings["styleGroups"](get(settings, "addressDetail"), view));

  return WrapperComponent ? /*#__PURE__*/React.createElement(WrapperComponent, _extends({
    object: object,
    objectPath: objectPath,
    className: (className || "") + " " + (get(settings, "customClassName") || ""),
    style: _extends({}, getStyleForSettings["styleGroups"](pick(settings, ["padding", "margin"]), view), style || {}, {
      width: "100%"
    })
  }, props), /*#__PURE__*/React.createElement("input", {
    className: styles.detail + " " + (get(valid, customFields.addressDetail) ? "" : styles.inValid),
    placeholder: get(settings, ["addressMore", "placeholders", "addressDetail"]) || "",
    style: addressDetailStyle,
    onChange: onChangeAddressDetail
  }), /*#__PURE__*/React.createElement(CountryRegionSelector, {
    countryCode: get(settings, ["addressMore", "countryCode"]) || "",
    value: (get(settings, ["addressMore", "customFields", "addressLevels"]) || []).map(function (cf) {
      return address[cf] || {
        name: null,
        code: null
      };
    }),
    customLayout: customLayout,
    componentLevels: {
      level0: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[0]
        })
      },
      level1: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[1]
        })
      },
      level2: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[2]
        })
      },
      level3: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[3]
        })
      },
      level4: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[4]
        })
      },
      level5: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[5]
        })
      }
    },
    onChange: onChangeAddress
  })) : /*#__PURE__*/React.createElement("div", _extends({
    className: (className || "") + " " + (get(settings, "customClassName") || ""),
    style: _extends({}, getStyleForSettings["margin"](settings.margin, view), style || {}, {
      width: "100%"
    })
  }, props), /*#__PURE__*/React.createElement("input", {
    className: styles.detail + " " + (get(valid, customFields.addressDetail) ? "" : styles.inValid),
    style: _extends({}, getStyleForSettings["styleGroups"](get(settings, "addressDetail"), view)),
    onChange: onChangeAddressDetail,
    placeholder: get(settings, ["addressMore", "placeholders", "addressDetail"]) || ""
  }), /*#__PURE__*/React.createElement(CountryRegionSelector, {
    countryCode: get(settings, ["addressMore", "countryCode"]) || "",
    value: (get(settings, ["addressMore", "customFields", "addressLevels"]) || []).map(function (cf) {
      return address[cf] || {
        name: null,
        code: null
      };
    }),
    customLayout: customLayout,
    componentLevels: {
      level0: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[0]
        })
      },
      level1: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[1]
        })
      },
      level2: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[2]
        })
      },
      level3: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[3]
        })
      },
      level4: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[4]
        })
      },
      level5: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: (get(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[5]
        })
      }
    },
    onChange: onChangeAddress
  }));
}