import "antd/lib/checkbox/style/css";
import _Checkbox from "antd/lib/checkbox";
var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect, useMemo } from "react";
import { get, pick, omit } from "lodash";
import { checkValidFormObjectData } from "../../utils/form-object.util";
import { getStyleForSettings } from "../../utils/style.util";
import styles from "./checkbox-styles.scss";
import "./overwrite.css";
export function BSFormObjectCheckbox(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? {} : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var customField = useMemo(function () {
    return get(object, ["settings", "customField"]);
  }, [get(object, ["settings", "customField"])]);

  var _useState = useState(get(object, "type")),
      type = _useState[0];

  var _useState2 = useState(get(object, ["settings", "checkboxGroupMore", "default"]) || []),
      value = _useState2[0],
      setValue = _useState2[1];

  var valid = useMemo(function () {
    return checkValidFormObjectData(type)(value, object);
  }, [object, get(object, ["settings", "checkboxGroupMore", "required"]), value]);
  var WrapperComponent = wrapperComponent;
  var settings = get(object, "settings") || {};
  console.log("settingsCheckbox", settings);

  var onChangeValue = function onChangeValue(e) {
    setValue(e);
  };

  useEffect(function () {
    var _onObjectData;

    customField && onObjectData && onObjectData((_onObjectData = {}, _onObjectData[customField] = value, _onObjectData));
  }, [value]);
  useEffect(function () {
    var _onValidData;

    customField && onValidData && onValidData((_onValidData = {}, _onValidData[customField] = valid, _onValidData));
  }, [valid]);
  return WrapperComponent ? /*#__PURE__*/React.createElement(WrapperComponent, {
    object: object,
    objectPath: objectPath,
    className: "" + (className || ""),
    style: _extends({}, getStyleForSettings["styleGroups"](pick(settings, ["margin", "alignment"]), view), {
      width: "auto"
    }, pick(style || {}, ["margin", "marginTop", "marginBottom", "marginLeft", "marginRight"]))
  }, /*#__PURE__*/React.createElement(_Checkbox.Group, _extends({
    className: "bs-form-object-components-checkbox " + (get(settings, ["customClassName"]) || ""),
    style: _extends({}, getStyleForSettings["styleGroups"](omit(settings, ["margin", "alignment"]), view), get(settings, ["checkboxGroupMore", "optionsDirection"]) === "horizontal" ? {} : {
      display: "flex",
      flexDirection: "column"
    }, omit(style || {}, ["margin", "marginTop", "marginBottom", "marginLeft", "marginRight"])),
    value: value,
    onChange: onChangeValue
  }, props), (get(settings, ["checkboxGroupMore", "options"]) || []).map(function (option) {
    return /*#__PURE__*/React.createElement(_Checkbox, {
      key: option.value,
      value: option.value,
      className: "" + (valid ? "" : styles.invalid),
      style: _extends({}, getStyleForSettings["optionStyle"](settings.checkboxGroupOptionStyle, view))
    }, option.label);
  }))) : /*#__PURE__*/React.createElement(_Checkbox.Group, _extends({
    className: "bs-form-object-components-checkbox " + (get(settings, ["customClassName"]) || ""),
    style: _extends({}, getStyleForSettings["styleGroups"](omit(settings, ["margin", "alignment"]), view), get(settings, ["checkboxGroupMore", "optionsDirection"]) === "horizontal" ? {} : {
      display: "flex",
      flexDirection: "column"
    }, omit(style || {}, ["margin", "marginTop", "marginBottom", "marginLeft", "marginRight"])),
    value: value,
    onChange: onChangeValue
  }, props), (get(settings, ["checkboxGroupMore", "options"]) || []).map(function (option) {
    return /*#__PURE__*/React.createElement(_Checkbox, {
      key: option.value,
      value: option.value,
      className: "" + (valid ? "" : styles.invalid),
      style: _extends({}, getStyleForSettings["optionStyle"](settings.checkboxGroupOptionStyle, view))
    }, option.label);
  }));
}