var _excluded = ["style", "className", "view", "throughProps", "object", "objectPath", "wrapperComponent", "onObjectData", "onSignalSubmit", "onValidData"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect, Fragment } from "react";
import { get } from "lodash";
import styles from "./container.styles.scss";
import { getDefaultView } from "../../utils/others.util";
import { getStyleForSettings } from "../../utils/style.util";
import { FORM_OBJECT_COMPONENT_MAPPINGS } from "../../definitions/form-object-component-mappings.definition";
import { VIEWS } from "../../definitions/views.definition";

var getStyleForEachCell = function getStyleForEachCell(cellIndex, view, containerSettings) {
  if (containerSettings === void 0) {
    containerSettings = {};
  }

  var style = {};

  if (view.width <= VIEWS.EXTRA_SMALL.MAX) {
    style.width = "100%";
  }

  if (view.width >= VIEWS.MOBILE.MIN && view.width <= VIEWS.MOBILE.MAX) {
    var columnCounts = get(containerSettings, ["columns", "counts"]);

    if (columnCounts <= 3) {
      style.width = "100%";
    } else {
      if (cellIndex === columnCounts - 1 && columnCounts % 2 !== 0) {
        style.width = "100%";
      } else {
        style.width = "50%";
      }
    }
  }

  if (view.width >= VIEWS.TABLET.MIN) {
    style.width = get(containerSettings, ["columns", "customColumnsWidth", cellIndex]);
  }

  return style;
};

export function BSFormObjectContainer(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? getDefaultView() : _ref$view,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      object = _ref.object,
      _ref$objectPath = _ref.objectPath,
      objectPath = _ref$objectPath === void 0 ? [] : _ref$objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState({}),
      objectData = _useState[0],
      setObjectData = _useState[1];

  var _useState2 = useState({}),
      validData = _useState2[0],
      setValidData = _useState2[1];

  var settings = get(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var onChangeObjectData = function onChangeObjectData(data) {
    if (data === void 0) {
      data = {};
    }

    return setObjectData(function (previousObjectData) {
      return _extends({}, previousObjectData, data);
    });
  };

  var onChangeValidData = function onChangeValidData(data) {
    if (data === void 0) {
      data = {};
    }

    return setValidData(function (previousObjectData) {
      return _extends({}, previousObjectData, data);
    });
  };

  useEffect(function () {
    onObjectData && onObjectData(objectData);
  }, [objectData]);
  useEffect(function () {
    onValidData && onValidData(validData);
  }, [validData]);
  var objectsRender = /*#__PURE__*/React.createElement(Fragment, null, (object.objects || []).map(function (childObject, index) {
    var FormObjectComponent = FORM_OBJECT_COMPONENT_MAPPINGS[childObject.type];
    return FormObjectComponent ? /*#__PURE__*/React.createElement(FormObjectComponent, {
      key: childObject.id,
      wrapperComponent: wrapperComponent,
      style: getStyleForEachCell(index, view, get(object, "settings")),
      view: view,
      object: childObject,
      objectPath: [].concat(objectPath, [index]),
      throughProps: throughProps,
      onObjectData: onChangeObjectData,
      onValidData: onChangeValidData,
      onSignalSubmit: onSignalSubmit
    }) : null;
  }));

  var wrapperStyle = _extends({}, getStyleForSettings["styleGroups"](settings, view), style || {}); // console.log("wrapper style", wrapperStyle);


  return wrapperComponent ? /*#__PURE__*/React.createElement(WrapperComponent, _extends({
    object: object,
    objectPath: objectPath,
    className: styles.container + " " + (className || "") + " " + (get(object, ["settings", "customClassName"]) || ""),
    style: _extends({}, wrapperStyle, {
      display: "flex"
    })
  }, props), objectsRender) : /*#__PURE__*/React.createElement("div", _extends({
    className: styles.container + " " + (className || "") + " " + (get(object, ["settings", "customClassName"]) || ""),
    style: _extends({}, wrapperStyle, {
      display: "flex"
    })
  }, props), objectsRender);
}