var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect, useMemo } from "react";
import { get, pick, omit } from "lodash";
import styles from "./input.styles.scss";
import { checkValidFormObjectData } from "../../utils/form-object.util";
import { getStyleForSettings } from "../../utils/style.util";
export function BSFormObjectInput(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? getDefaultView() : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var customField = useMemo(function () {
    return get(object, ["settings", "customField"]);
  }, [get(object, ["settings", "customField"])]);

  var _useState = useState(get(object, "type")),
      type = _useState[0];

  var _useState2 = useState(get(object, ["settings", "inputMore", "default"]) || ""),
      text = _useState2[0],
      setText = _useState2[1];

  var valid = useMemo(function () {
    return checkValidFormObjectData(type)(text, object);
  }, [object, get(object, ["settings", "inputMore", "required"]), get(object, ["settings", "inputMore", "inputType"]), text]);
  var settings = get(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var onChangeText = function onChangeText(e) {
    var newText = e.target.value;
    setText(newText);
  };

  useEffect(function () {
    var _onObjectData;

    customField && onObjectData && onObjectData((_onObjectData = {}, _onObjectData[customField] = text, _onObjectData));
  }, [text]);
  useEffect(function () {
    var _onValidData;

    customField && onValidData && onValidData((_onValidData = {}, _onValidData[customField] = valid, _onValidData));
  }, [valid]);
  return wrapperComponent ? /*#__PURE__*/React.createElement(WrapperComponent, {
    object: object,
    objectPath: objectPath,
    className: "" + (className || ""),
    style: _extends({}, getStyleForSettings["margin"](settings.margin, view), getStyleForSettings["width"](settings.width, view), pick(style || {}, ["margin", "marginLeft", "marginRight", "marginTop", "marginBottom", "width", "minWidth", "maxWidth"]))
  }, /*#__PURE__*/React.createElement("input", _extends({
    className: styles.input + " " + (get(settings, "customClassName") || "") + " " + (!valid ? styles.validError : ""),
    type: get(settings, ["inputMore", "inputType"]),
    name: get(settings, ["customField"]),
    placeholder: get(settings, ["inputMore", "placeholder"]) || "",
    value: text,
    onChange: onChangeText,
    style: _extends({}, getStyleForSettings["styleGroups"](omit(settings, ["width", "margin"]), view), {
      width: "100%"
    }, omit(style || {}, ["margin", "marginLeft", "marginRight", "marginTop", "marginBottom", "width", "minWidth", "maxWidth"]))
  }, props))) : /*#__PURE__*/React.createElement("input", _extends({
    className: styles.input + " " + (className || "") + " " + (get(settings, "customClassName") || "") + " " + (!valid ? styles.validError : ""),
    type: get(settings, ["inputMore", "inputType"]),
    name: get(settings, ["customField"]),
    placeholder: get(settings, ["inputMore", "placeholder"]) || "",
    value: text,
    onChange: onChangeText,
    style: _extends({}, getStyleForSettings["styleGroups"](settings, view), style || {})
  }, props));
}