import "antd/lib/select/style/css";
import _Select from "antd/lib/select";
var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect, useMemo } from "react";
import { get, omit, pick } from "lodash";
import { checkValidFormObjectData } from "../../utils/form-object.util";
import { getStyleForSettings } from "../../utils/style.util";
import styles from "./select.styles.scss";
import "./overwrite.css";
var Option = _Select.Option;
export function BSFormObjectSelect(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? getDefaultView() : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var customField = useMemo(function () {
    return get(object, ["settings", "customField"]);
  }, [get(object, ["settings", "customField"])]);

  var _useState = useState(get(object, "type")),
      type = _useState[0];

  var _useState2 = useState(get(object, ["settings", "selectMore", "default"]) || null),
      value = _useState2[0],
      setValue = _useState2[1];

  var valid = useMemo(function () {
    return checkValidFormObjectData(type)(value, object);
  }, [object, get(object, ["settings", "selectMore", "required"]), value]);
  var settings = get(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var onChangeSelection = function onChangeSelection(newValue) {
    setValue(newValue);
  };

  useEffect(function () {
    var _onObjectData;

    customField && onObjectData && onObjectData((_onObjectData = {}, _onObjectData[customField] = value, _onObjectData));
  }, [value]);
  useEffect(function () {
    var _onValidData;

    customField && onValidData && onValidData((_onValidData = {}, _onValidData[customField] = valid, _onValidData));
  }, [valid]);
  return WrapperComponent ? /*#__PURE__*/React.createElement(WrapperComponent, {
    object: object,
    objectPath: objectPath,
    className: (className || "") + " " + (get(settings, "customClassName") || ""),
    style: _extends({
      display: "inline-block"
    }, getStyleForSettings["styleGroups"](pick(settings, ["margin", "alignment"])), getStyleForSettings["width"](settings.selectBoxStyle.width, view), omit(style || {}, ["width"]))
  }, /*#__PURE__*/React.createElement(_Select, _extends({
    className: "bs-form-object-components-select " + (valid ? "" : styles.inValid) + " " + (className || "") + " " + (get(settings, "customClassName") || ""),
    style: _extends({}, getStyleForSettings["styleGroups"](omit(settings, ["alignment", "margin", "selectBoxStyle"])), getStyleForSettings["selectBoxStyle"](settings.selectBoxStyle, view, ["width"]), style || {}, {
      width: "100%"
    }),
    dropdownClassName: styles.dropdown,
    dropdownStyle: {
      width: "auto",
      maxWidth: "auto"
    },
    placeholder: get(settings, ["selectMore", "placeholder"]) || "",
    value: value || undefined,
    onChange: onChangeSelection
  }, props), (get(settings, ["selectMore", "options"]) || []).map(function (option) {
    return /*#__PURE__*/React.createElement(Option, {
      key: option.value,
      value: option.value,
      style: _extends({}, getStyleForSettings["optionStyle"](settings.optionStyle, view))
    }, option.label);
  }))) : /*#__PURE__*/React.createElement(_Select, _extends({
    className: "bs-form-object-components-select " + (valid ? "" : styles.inValid) + " " + (className || "") + " " + (get(settings, "customClassName") || ""),
    style: _extends({}, getStyleForSettings["styleGroups"](settings, view), style || {}, {
      display: "flex",
      alignItems: "center"
    }),
    dropdownClassName: styles.dropdown,
    dropdownStyle: {
      width: "auto",
      maxWidth: "auto"
    },
    placeholder: get(settings, ["selectMore", "placeholder"]) || "",
    value: value || undefined,
    onChange: onChangeSelection
  }, props), (get(settings, ["selectMore", "options"]) || []).map(function (option) {
    return /*#__PURE__*/React.createElement(Option, {
      key: option.value,
      value: option.value,
      style: _extends({}, getStyleForSettings["optionStyle"](settings.optionStyle, view))
    }, option.label);
  }));
}