import "antd/lib/input/style/css";
import _Input from "antd/lib/input";
var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect, useMemo } from "react";
import { get, pick, omit } from "lodash";
import { checkValidFormObjectData } from "../../utils/form-object.util";
import { getStyleForSettings } from "../../utils/style.util";
import styles from "./textarea.styles.scss";
export function BSFormObjectTextarea(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? getDefaultView() : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var customField = useMemo(function () {
    return get(object, ["settings", "customField"]);
  }, [get(object, ["settings", "customField"])]);

  var _useState = useState(get(object, "type")),
      type = _useState[0];

  var _useState2 = useState(get(object, ["settings", "textareaMore", "default"]) || null),
      value = _useState2[0],
      setValue = _useState2[1];

  var valid = useMemo(function () {
    return checkValidFormObjectData(type)(value, object);
  }, [object, get(object, ["settings", "textareaMore", "required"]), value]);
  var settings = get(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var onChangeValue = function onChangeValue(e) {
    setValue(e.target.value);
  };

  useEffect(function () {
    var _onObjectData;

    customField && onObjectData && onObjectData((_onObjectData = {}, _onObjectData[customField] = value, _onObjectData));
  }, [value]);
  useEffect(function () {
    var _onValidData;

    customField && onValidData && onValidData((_onValidData = {}, _onValidData[customField] = valid, _onValidData));
  }, [valid]);
  return WrapperComponent ? /*#__PURE__*/React.createElement(WrapperComponent, {
    object: object,
    objectPath: objectPath,
    className: "" + (className || ""),
    style: _extends({
      height: "auto"
    }, getStyleForSettings["styleGroups"](pick(settings, ["margin", "alignment", "width"]), view), pick(style || {}, ["margin", "marginTop", "marginBottom", "marginLeft", "marginRight", "width", "minWidth", "maxWidth"]))
  }, /*#__PURE__*/React.createElement(_Input.TextArea, _extends({
    className: (get(settings, ["customClassName"]) || "") + " " + (valid ? "" : styles.inValid),
    style: _extends({}, getStyleForSettings["styleGroups"](omit(settings, ["margin", "alignment", "width"]), view), omit(style || {}, ["margin", "marginTop", "marginBottom", "marginLeft", "marginRight", "width", "minWidth", "maxWidth"])),
    placeholder: get(settings, ["textareaMore", "placeholder"]) || "",
    value: value,
    onChange: onChangeValue,
    autoSize: true
  }, props))) : /*#__PURE__*/React.createElement(_Input.TextArea, _extends({
    className: (className || "") + " " + (get(object, ["settings", "customClassName"]) || "") + " " + (valid ? "" : styles.inValid),
    style: _extends({}, getStyleForSettings["styleGroups"](settings, view), style || {}),
    placeholder: get(settings, ["textareaMore", "placeholder"]) || "",
    value: value,
    onChange: onChangeValue,
    autoSize: true
  }, props));
}