var _excluded = ["style", "className", "view", "throughProps", "object", "objectPath", "wrapperComponent", "onObjectData", "onSignalSubmit", "onValidData"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import { get, omit } from "lodash";
import styles from "./styles.scss";
import { getDefaultView } from "../../utils/others.util";
import { getStyleForSettings } from "../../utils/style.util";
export function BsFormObjectVideo(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? getDefaultView() : _ref$view,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      object = _ref.object,
      _ref$objectPath = _ref.objectPath,
      objectPath = _ref$objectPath === void 0 ? [] : _ref$objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var settings = get(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var wrapperStyle = _extends({}, getStyleForSettings["styleGroups"](settings, view), style || {});

  var genSrc = function genSrc(url) {
    try {
      var myUrl = new URL(url);
      var searchParams = new URLSearchParams(myUrl.search.slice(1));
      var videoId = searchParams.get("v");

      var _get = get(object, ["settings", "video", "play"]),
          mute = _get.mute,
          loop = _get.loop,
          autoPlay = _get.autoPlay;

      var ytUrl = "https://www.youtube.com/embed/" + videoId + "?autoplay=" + Number(autoPlay) + "&mute=" + Number(mute);

      if (loop) {
        ytUrl = "https://www.youtube.com/embed/" + videoId + "?autoplay=" + Number(autoPlay) + "&loop=" + Number(loop) + "&mute=" + Number(mute) + "&playlist=" + videoId;
      }

      ytUrl += "&showinfo=0&rel=0";
      return ytUrl;
    } catch (err) {
      console.log(err);
      return "";
    }
  };

  var genPaddingTop = function genPaddingTop() {
    var _get$split = get(object, ["settings", "video", "aspect"]).split(":"),
        num1 = _get$split[0],
        num2 = _get$split[1];

    if (!get(object, ["settings", "video", "url"])) {
      var paddingTop = get(object, ["settings", "padding", "paddingTop"]);

      var _paddingTop$match = paddingTop.match(/\d+/),
          num = _paddingTop$match[0];

      return parseInt(num) + "px";
    }

    return parseInt(num2) / parseInt(num1) * 100 + "%";
  };

  return wrapperComponent ? /*#__PURE__*/React.createElement(WrapperComponent, _extends({
    object: object,
    objectPath: objectPath,
    style: _extends({}, wrapperStyle)
  }, props), /*#__PURE__*/React.createElement("div", _extends({
    className: styles.container + " " + (className || "") + " " + (get(object, ["settings", "customClassName"]) || ""),
    style: {
      width: "100%",
      height: "100%"
    }
  }, props), !get(object, ["settings", "video", "url"]) ? /*#__PURE__*/React.createElement("div", {
    className: styles.imageHolder
  }, /*#__PURE__*/React.createElement("i", {
    className: styles.icon
  }, /*#__PURE__*/React.createElement("svg", {
    width: "33.325",
    height: "23.65",
    viewBox: "0 -61 512 512",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React.createElement("path", {
    d: "m75 390h362c41.355469 0 75-33.644531 75-75v-240c0-41.355469-33.644531-75-75-75h-362c-41.355469 0-75 33.644531-75 75v240c0 41.355469 33.644531 75 75 75zm-45-315c0-24.8125 20.1875-45 45-45h362c24.8125 0 45 20.1875 45 45v240c0 24.8125-20.1875 45-45 45h-362c-24.8125 0-45-20.1875-45-45zm0 0",
    style: {
      fill: "#5552d5"
    }
  }), /*#__PURE__*/React.createElement("path", {
    d: "m181 94.507812v203.898438l180.5-103.621094zm30 50.984376 89.5 49.722656-89.5 51.378906zm0 0",
    style: {
      fill: "#5552d5"
    }
  }))), /*#__PURE__*/React.createElement("div", {
    style: {
      color: "#5552d5",
      textAlign: "center"
    }
  }, "Youtube video link")) : /*#__PURE__*/React.createElement("iframe", {
    width: "100%",
    height: "100%",
    src: genSrc(get(object, ["settings", "video", "url"])),
    frameBorder: "0",
    allow: "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture",
    allowFullScreen: true
  }))) : /*#__PURE__*/React.createElement("div", _extends({
    className: styles.container + " " + (className || "") + " " + (get(object, ["settings", "customClassName"]) || ""),
    style: _extends({}, wrapperStyle, {
      width: "100%",
      height: "100%",
      position: "relative",
      paddingTop: genPaddingTop()
    })
  }, props), !get(object, ["settings", "video", "url"]) ? /*#__PURE__*/React.createElement("div", {
    className: styles.imageHolder
  }, /*#__PURE__*/React.createElement("i", {
    className: styles.icon
  }, /*#__PURE__*/React.createElement("svg", {
    width: "33.325",
    height: "23.65",
    viewBox: "0 -61 512 512",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React.createElement("path", {
    d: "m75 390h362c41.355469 0 75-33.644531 75-75v-240c0-41.355469-33.644531-75-75-75h-362c-41.355469 0-75 33.644531-75 75v240c0 41.355469 33.644531 75 75 75zm-45-315c0-24.8125 20.1875-45 45-45h362c24.8125 0 45 20.1875 45 45v240c0 24.8125-20.1875 45-45 45h-362c-24.8125 0-45-20.1875-45-45zm0 0",
    style: {
      fill: "#5552d5"
    }
  }), /*#__PURE__*/React.createElement("path", {
    d: "m181 94.507812v203.898438l180.5-103.621094zm30 50.984376 89.5 49.722656-89.5 51.378906zm0 0",
    style: {
      fill: "#5552d5"
    }
  }))), /*#__PURE__*/React.createElement("div", {
    style: {
      color: "#5552d5",
      textAlign: "center"
    }
  }, "Youtube video link")) : /*#__PURE__*/React.createElement("iframe", {
    width: "100%",
    height: "100%",
    style: {
      position: "absolute",
      top: 0,
      left: 0
    },
    src: genSrc(get(object, ["settings", "video", "url"])),
    frameBorder: "0",
    allow: "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture",
    allowFullScreen: true
  }));
}