import _regeneratorRuntime from "@babel/runtime/regenerator";

var _formObjectGenerators, _checkValidFormObject;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import { get, flattenDeep, isEmpty, isNull, isUndefined } from "lodash";
import { getListLevel } from "country-region-selector";
import { FORM_OBJECT_TYPES } from "../definitions/form-object-types.definition";
import { FORM_OBJECT_TYPES_CAN_HAVE_USER_VALUE } from "../definitions/form-object-types.definition";
import { INPUT_TYPES } from "../definitions/input-types.definition";
export var formObjectGenerators = (_formObjectGenerators = {}, _formObjectGenerators[FORM_OBJECT_TYPES.CONTAINER] = function (id) {
  return {
    id: id,
    name: "container",
    type: FORM_OBJECT_TYPES.CONTAINER,
    settings: {
      columns: {
        counts: 1,
        spacing: 0,
        equalColumnsWidth: true,
        customColumnsWidth: ["100%"]
      },
      width: {
        fullWidth: true,
        isAuto: false,
        custom: "0px"
      },
      height: {
        minHeight: "50px"
      },
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "0px",
        paddingBottom: "0px",
        paddingLeft: "0px",
        paddingRight: "0px"
      },
      border: {
        borderWidth: "0px",
        borderColor: "#000",
        borderStyle: "solid",
        borderRadius: "0px"
      },
      background: {
        backgroundColor: "#fff",
        backgroundImage: {
          url: null,
          size: "contain",
          position: "left top",
          repeat: "no-repeat"
        }
      },
      shadow: {
        horizontal: "0px",
        vertical: "0px",
        blur: "0px",
        spread: "0px",
        color: "#000"
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.CELL] = function (id) {
  return {
    id: id,
    name: "cell",
    type: FORM_OBJECT_TYPES.CELL,
    settings: {
      height: {
        minHeight: "50px"
      },
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "5px",
        paddingBottom: "5px",
        paddingLeft: "5px",
        paddingRight: "5px"
      },
      border: {
        borderWidth: "0px",
        borderColor: "#000",
        borderStyle: "solid",
        borderRadius: "0px"
      },
      background: {
        backgroundColor: "#fff",
        backgroundImage: {
          url: null,
          size: "contain",
          position: "left top",
          repeat: "no-repeat"
        }
      },
      shadow: {
        horizontal: "0px",
        vertical: "0px",
        blur: "0px",
        spread: "0px",
        color: "#000"
      },
      contentAlignment: {
        horizontal: "flex-start",
        vertical: "flex-start"
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.BUTTON] = function (id) {
  return {
    id: id,
    name: "button",
    type: FORM_OBJECT_TYPES.BUTTON,
    settings: {
      width: {
        fullWidth: false,
        isAuto: true,
        custom: "0px"
      },
      height: {
        minHeight: "50px"
      },
      margin: {
        marginTop: "0px",
        marginBottom: "0px"
      },
      padding: {
        paddingTop: "5px",
        paddingBottom: "5px",
        paddingLeft: "10px",
        paddingRight: "10px"
      },
      alignment: "center",
      contentAlignment: {
        horizontal: "center",
        vertical: "center"
      },
      text: {
        family: "Roboto",
        size: "14px",
        weight: "normal",
        style: "normal"
      },
      buttonStates: {
        normal: {
          text: {
            color: "#fff"
          },
          border: {
            borderWidth: "0px",
            borderColor: "#000",
            borderStyle: "solid",
            borderRadius: "0px"
          },
          shadow: {
            horizontal: "0px",
            vertical: "2px",
            blur: "0px",
            spread: "0px",
            color: "rgba(0,0,0,0.045)"
          },
          background: {
            backgroundColor: "#1890ff",
            backgroundImage: {
              url: null,
              size: "contain",
              position: "left top",
              repeat: "no-repeat"
            }
          }
        },
        hover: {
          text: {
            color: "#fff"
          },
          border: {
            borderWidth: "0px",
            borderColor: "#000",
            borderStyle: "solid",
            borderRadius: "0px"
          },
          shadow: {
            horizontal: "0px",
            vertical: "2px",
            blur: "0px",
            spread: "0px",
            color: "rgba(0,0,0,0.045)"
          },
          background: {
            backgroundColor: "#40a9ff",
            backgroundImage: {
              url: null,
              size: "contain",
              position: "left top",
              repeat: "no-repeat"
            }
          }
        },
        active: {
          text: {
            color: "#fff"
          },
          border: {
            borderWidth: "0px",
            borderColor: "#000",
            borderStyle: "solid",
            borderRadius: "0px"
          },
          shadow: {
            horizontal: "0px",
            vertical: "2px",
            blur: "0px",
            spread: "0px",
            color: "rgba(0,0,0,0.045)"
          },
          background: {
            backgroundColor: "#40a9ff",
            backgroundImage: {
              url: null,
              size: "contain",
              position: "left top",
              repeat: "no-repeat"
            }
          }
        }
      },
      buttonMore: {
        label: "Button"
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.LABEL] = function (id) {
  return {
    id: id,
    name: "label",
    type: FORM_OBJECT_TYPES.LABEL,
    settings: {
      margin: {
        marginTop: "5px",
        marginBottom: "5px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "0px",
        paddingBottom: "0px",
        paddingLeft: "0px",
        paddingRight: "0px"
      },
      text: {
        family: "Roboto",
        size: "14px",
        color: "#000",
        alignment: "left",
        weight: "normal",
        style: "normal"
      },
      labelMore: {
        label: "Label"
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.INPUT] = function (id) {
  return {
    id: id,
    name: "input",
    type: FORM_OBJECT_TYPES.INPUT,
    settings: {
      width: {
        fullWidth: true,
        isAuto: false,
        custom: "0px"
      },
      height: {
        height: "30px"
      },
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "4px",
        paddingBottom: "4px",
        paddingLeft: "11px",
        paddingRight: "11px"
      },
      border: {
        borderWidth: "1px",
        borderColor: "#d9d9d9",
        borderStyle: "solid",
        borderRadius: "2px"
      },
      background: {
        backgroundColor: "#fff",
        backgroundImage: {
          url: null,
          size: "contain",
          position: "left top",
          repeat: "no-repeat"
        }
      },
      shadow: {
        horizontal: "0px",
        vertical: "0px",
        blur: "0px",
        spread: "0px",
        color: "#000"
      },
      text: {
        family: "Roboto",
        size: "16px",
        color: "rgba(0,0,0,0.65)",
        alignment: "left",
        weight: "normal",
        style: "normal"
      },
      inputMore: {
        placeholder: null,
        inputType: "text",
        "default": "",
        required: false
      },
      customField: null,
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.TEXTAREA] = function (id) {
  return {
    id: id,
    name: "textarea",
    type: FORM_OBJECT_TYPES.TEXTAREA,
    settings: {
      width: {
        fullWidth: true,
        isAuto: false,
        custom: "0px"
      },
      height: {
        minHeight: "50px",
        height: "50px"
      },
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "10px",
        paddingBottom: "10px",
        paddingLeft: "10px",
        paddingRight: "10px"
      },
      border: {
        borderWidth: "1px",
        borderColor: "rgba(0,0,0,0.16)",
        borderStyle: "solid",
        borderRadius: "2px"
      },
      background: {
        backgroundColor: "#fff",
        backgroundImage: {
          url: null,
          size: "contain",
          position: "left top",
          repeat: "no-repeat"
        }
      },
      shadow: {
        horizontal: "0px",
        vertical: "0px",
        blur: "0px",
        spread: "0px",
        color: "#000"
      },
      alignment: "left",
      text: {
        family: "Roboto",
        size: "16px",
        color: "rgba(0,0,0,0.65)",
        alignment: "left",
        weight: "normal",
        style: "normal"
      },
      textareaMore: {
        "default": "",
        required: false,
        placeholder: null
      },
      customField: null,
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.SELECT] = function (id) {
  return {
    id: id,
    name: "select",
    type: FORM_OBJECT_TYPES.SELECT,
    settings: {
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      alignment: "left",
      selectOptionStyle: {
        text: {
          family: "Roboto",
          size: "14px",
          color: "#000",
          alignment: "left",
          weight: "normal",
          style: "normal"
        }
      },
      selectBoxStyle: {
        width: {
          fullWidth: true,
          isAuto: false,
          custom: "0px"
        },
        border: {
          borderColor: "rgba(0,0,0,0.16)",
          borderRadius: "2px",
          borderStyle: "solid",
          borderWidth: "1px"
        },
        background: {
          backgroundColor: "#fff"
        },
        text: {
          family: "Roboto",
          size: "14px",
          color: "#000",
          alignment: "left",
          weight: "normal",
          style: "normal"
        }
      },
      selectMore: {
        options: [{
          value: "1",
          label: "Option 01"
        }, {
          value: "2",
          label: "Option 02"
        }, {
          value: "3",
          label: "Option 03"
        }],
        placeholder: null,
        "default": "1",
        required: false
      },
      customField: null,
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.RADIO] = function (id) {
  return {
    id: id,
    name: "radio",
    type: FORM_OBJECT_TYPES.RADIO,
    settings: {
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      alignment: "left",
      text: {
        family: "Roboto",
        size: "14px",
        color: "#000",
        weight: "normal",
        style: "normal"
      },
      radioMore: {
        "default": false,
        label: "Radio"
      },
      customField: null,
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.RADIO_GROUP] = function (id) {
  return {
    id: id,
    name: "radio group",
    type: FORM_OBJECT_TYPES.RADIO_GROUP,
    settings: {
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      alignment: "left",
      radioGroupOptionStyle: {
        text: {
          family: "Roboto",
          size: "14px",
          color: "#000",
          weight: "normal",
          style: "normal"
        }
      },
      radioGroupMore: {
        options: [{
          value: "1",
          label: "Option 01"
        }, {
          value: "2",
          label: "Option 02"
        }, {
          value: "3",
          label: "Option 03"
        }],
        "default": null,
        required: false,
        optionsDirection: "vertical"
      },
      customField: null,
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.HEADING] = function (id) {
  return {
    id: id,
    name: "heading",
    type: FORM_OBJECT_TYPES.HEADING,
    settings: {
      margin: {
        marginTop: "5px",
        marginBottom: "5px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "0px",
        paddingBottom: "0px",
        paddingLeft: "0px",
        paddingRight: "0px"
      },
      text: {
        family: "Roboto",
        size: "25px",
        color: "#000",
        alignment: "left",
        weight: "normal",
        style: "normal"
      },
      headingMore: {
        label: "Heading"
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.ADDRESS] = function (id) {
  return {
    id: id,
    name: "address",
    type: FORM_OBJECT_TYPES.ADDRESS,
    settings: {
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "0px",
        paddingBottom: "0px",
        paddingLeft: "0px",
        paddingRight: "0px"
      },
      addressDetail: {
        width: {
          fullWidth: true,
          isAuto: false,
          custom: "0px"
        },
        height: {
          height: "27px"
        },
        margin: {
          marginTop: "0px",
          marginBottom: "5px",
          marginLeft: "0px",
          marginRight: "0px"
        },
        padding: {
          paddingTop: "5px",
          paddingBottom: "5px",
          paddingLeft: "6px",
          paddingRight: "6px"
        },
        border: {
          borderColor: "rgba(0,0,0,0.16)",
          borderStyle: "solid",
          borderWidth: "1px",
          borderRadius: "0px"
        },
        background: {
          backgroundColor: "#fff"
        },
        text: {
          family: "Roboto",
          color: "#000",
          size: "16px",
          weight: "normal",
          style: "normal",
          alignment: "left"
        }
      },
      addressLevelSelector: {
        width: {
          fullWidth: true,
          isAuto: true,
          custom: "0px"
        },
        height: {
          height: "25px"
        },
        margin: {
          marginTop: "0px",
          marginBottom: "0px",
          marginLeft: "0px",
          marginRight: "0px"
        },
        border: {
          borderColor: "rgba(0,0,0,0.16)",
          borderStyle: "solid",
          borderWidth: "1px",
          borderRadius: "0px"
        },
        background: {
          backgroundColor: "#fff"
        },
        text: {
          family: "Roboto",
          color: "#000",
          size: "16px",
          weight: "normal",
          style: "normal",
          alignment: "left"
        }
      },
      addressLevelLabel: {
        margin: {
          marginTop: "0px",
          marginBottom: "0px",
          marginLeft: "0px",
          marginRight: "0px"
        },
        padding: {
          paddingTop: "0px",
          paddingBottom: "0px",
          paddingLeft: "0px",
          paddingRight: "0px"
        },
        text: {
          family: "Roboto",
          color: "#000",
          size: "13px",
          weight: "normal",
          style: "normal",
          alignment: "left"
        },
        addressLevelLabelDisplayLabel: true
      },
      addressMore: {
        countryCode: null,
        customFields: {
          addressDetail: null,
          addressLevels: []
        },
        placeholders: {
          addressDetail: null,
          addressLevels: []
        },
        required: false
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.NEW_LINE] = function (id) {
  return {
    id: id,
    name: "new line",
    type: FORM_OBJECT_TYPES.NEW_LINE,
    settings: {
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.TEXT] = function (id) {
  return {
    id: id,
    name: "text",
    type: FORM_OBJECT_TYPES.TEXT,
    settings: {
      margin: {
        marginTop: "5px",
        marginBottom: "5px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "0px",
        paddingBottom: "0px",
        paddingLeft: "0px",
        paddingRight: "0px"
      },
      text: {
        family: "Roboto",
        size: "13px",
        color: "#000",
        alignment: "left",
        weight: "normal",
        style: "normal",
        shadow: {
          horizontal: "0px",
          vertical: "0px",
          blur: "0px",
          spread: "0px",
          color: "#000"
        }
      },
      textMore: {
        label: "Text"
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.IMAGE] = function (id) {
  return {
    id: id,
    name: "image",
    type: FORM_OBJECT_TYPES.IMAGE,
    settings: {
      width: {
        fullWidth: true,
        isAuto: false,
        custom: "0px"
      },
      height: {
        height: "150px"
      },
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "0px",
        paddingBottom: "0px",
        paddingLeft: "0px",
        paddingRight: "0px"
      },
      border: {
        borderWidth: "0px",
        borderColor: "#000000",
        borderStyle: "solid",
        borderRadius: "0px"
      },
      shadow: {
        horizontal: "0px",
        vertical: "0px",
        blur: "0px",
        spread: "0px",
        color: "#000"
      },
      alignment: "center",
      image: {
        url: null
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.VIDEO] = function (id) {
  return {
    id: id,
    name: "video",
    type: FORM_OBJECT_TYPES.VIDEO,
    settings: {
      width: {
        fullWidth: true,
        isAuto: false,
        custom: "0px"
      },
      height: {
        minHeight: "80px"
      },
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      padding: {
        paddingTop: "10px",
        paddingBottom: "10px",
        paddingLeft: "0px",
        paddingRight: "0px"
      },
      alignment: "center",
      border: {
        borderWidth: "0px",
        borderColor: "#000000",
        borderStyle: "solid",
        borderRadius: "0px"
      },
      shadow: {
        horizontal: "0px",
        vertical: "0px",
        blur: "0px",
        spread: "0px",
        color: "#000"
      },
      video: {
        url: null,
        aspect: "16:9",
        play: {
          loop: false,
          autoPlay: false,
          mute: false
        }
      },
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators[FORM_OBJECT_TYPES.CHECKBOX] = function (id) {
  return {
    id: id,
    name: "checkbox",
    type: FORM_OBJECT_TYPES.CHECKBOX,
    settings: {
      margin: {
        marginTop: "0px",
        marginBottom: "0px",
        marginLeft: "0px",
        marginRight: "0px"
      },
      alignment: "left",
      checkboxGroupOptionStyle: {
        text: {
          family: "Roboto",
          size: "14px",
          color: "#000",
          weight: "normal",
          style: "normal"
        }
      },
      checkboxGroupMore: {
        options: [{
          value: "1",
          label: "Option 01"
        }, {
          value: "2",
          label: "Option 02"
        }, {
          value: "3",
          label: "Option 03"
        }],
        required: false,
        optionsDirection: "vertical"
      },
      customField: null,
      customClassName: null
    },
    objects: []
  };
}, _formObjectGenerators);
export var getRequiredFields = function getRequiredFields(objects) {
  if (objects === void 0) {
    objects = [];
  }

  if (isEmpty(objects)) {
    return [];
  }

  var fields = [];

  for (var _iterator = _createForOfIteratorHelperLoose(objects), _step; !(_step = _iterator()).done;) {
    var object = _step.value;

    if (get(object, ["settings", "customField"]) && get(object, ["settings", "specials", "required"])) {
      fields.push(get(object, ["settings", "customField"]));
    }

    fields.push(getRequiredFields(get(object, "objects")));
  }

  return flattenDeep(fields);
};
var checkValidFormObjectDataMappings = (_checkValidFormObject = {}, _checkValidFormObject[FORM_OBJECT_TYPES.INPUT] = function (value, object) {
  if (object === void 0) {
    object = {};
  }

  var settings = get(object, "settings") || {};
  var type = get(settings, ["inputMore", "inputType"]);
  var required = get(settings, ["inputMore", "required"]);

  if (value === "" && required) {
    return false;
  }

  if (value === "") {
    return true;
  }

  if ((type === INPUT_TYPES.NUMBER || type === INPUT_TYPES.PHONE) && value.search(/^[0-9]+$/) !== 0) {
    return false;
  }

  if (type === INPUT_TYPES.EMAIL && value.search(/^([a-zA-Z0-9_\-\.]+)@([a-zA-Z0-9_\-\.]+)\.([a-zA-Z]{2,5})$/) !== 0) {
    return false;
  }

  return true;
}, _checkValidFormObject[FORM_OBJECT_TYPES.ADDRESS] = function (value, object) {
  var _validObj;

  if (object === void 0) {
    object = {};
  }

  var settings = get(object, "settings") || {};
  var customFields = get(settings, ["addressMore", "customFields"]) || {};
  var validObj = (_validObj = {}, _validObj[customFields.addressDetail] = true, _validObj);
  (customFields.addressLevels || []).map(function (cf) {
    return validObj[cf] = true;
  });

  if (!get(settings, ["addressMore", "required"])) {
    return validObj;
  }

  for (var cf in validObj) {
    if (isEmpty(get(value, cf))) {
      validObj[cf] = false;
    }
  }

  return validObj;
}, _checkValidFormObject[FORM_OBJECT_TYPES.SELECT] = function (value, object) {
  if (object === void 0) {
    object = {};
  }

  var settings = get(object, "settings") || {};

  if (!get(settings, ["selectMore", "required"])) {
    return true;
  }

  if (isEmpty(value)) {
    return false;
  }

  return true;
}, _checkValidFormObject[FORM_OBJECT_TYPES.RADIO_GROUP] = function (value, object) {
  if (object === void 0) {
    object = {};
  }

  var settings = get(object, "settings") || {};

  if (!get(settings, ["radioGroupMore", "required"])) {
    return true;
  }

  if (isEmpty(value)) {
    return false;
  }

  return true;
}, _checkValidFormObject[FORM_OBJECT_TYPES.TEXTAREA] = function (value, object) {
  if (object === void 0) {
    object = {};
  }

  var settings = get(object, "settings") || {};

  if (!get(settings, ["textareaMore", "required"])) {
    return true;
  }

  if (isEmpty(value)) {
    return false;
  }

  return true;
}, _checkValidFormObject[FORM_OBJECT_TYPES.RADIO] = function (value, object) {
  if (object === void 0) {
    object = {};
  }

  var settings = get(object, "settings") || {};

  if (!get(settings, ["radioMore", "required"])) {
    return true;
  }

  if (isNull(value) || isUndefined(value)) {
    return false;
  }

  return true;
}, _checkValidFormObject);
export var checkValidFormObjectData = function checkValidFormObjectData(objectType) {
  return function (value, object) {
    var checkFunc = checkValidFormObjectDataMappings[objectType];
    return checkFunc ? checkFunc(value, object) : true;
  };
};
export var checkValidFormObjectsToUse = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(objects) {
    var _iterator2, _step2, object, _ref2, countryCode, _ref2$customFields, customFields, levels;

    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (objects === void 0) {
              objects = [];
            }

            _iterator2 = _createForOfIteratorHelperLoose(objects);

          case 2:
            if ((_step2 = _iterator2()).done) {
              _context.next = 24;
              break;
            }

            object = _step2.value;

            if (!(object.type === FORM_OBJECT_TYPES.ADDRESS)) {
              _context.next = 18;
              break;
            }

            _ref2 = get(object, ["settings", "addressMore"]) || {}, countryCode = _ref2.countryCode, _ref2$customFields = _ref2.customFields, customFields = _ref2$customFields === void 0 ? {} : _ref2$customFields;

            if (!(isEmpty(countryCode) || isEmpty(customFields.addressDetail))) {
              _context.next = 8;
              break;
            }

            return _context.abrupt("return", false);

          case 8:
            _context.next = 10;
            return getListLevel(countryCode);

          case 10:
            _context.t0 = _context.sent;

            if (_context.t0) {
              _context.next = 13;
              break;
            }

            _context.t0 = [];

          case 13:
            levels = _context.t0;

            if (!(levels.length !== (customFields.addressLevels || []).length)) {
              _context.next = 16;
              break;
            }

            return _context.abrupt("return", false);

          case 16:
            if (!(customFields.addressLevels || []).some(function (cf) {
              return isEmpty(cf);
            })) {
              _context.next = 18;
              break;
            }

            return _context.abrupt("return", false);

          case 18:
            if (!(object.type !== FORM_OBJECT_TYPES.ADDRESS && FORM_OBJECT_TYPES_CAN_HAVE_USER_VALUE[object.type] && !get(object, ["settings", "customField"]))) {
              _context.next = 20;
              break;
            }

            return _context.abrupt("return", false);

          case 20:
            if (checkValidFormObjectsToUse(object.objects)) {
              _context.next = 22;
              break;
            }

            return _context.abrupt("return", false);

          case 22:
            _context.next = 2;
            break;

          case 24:
            return _context.abrupt("return", true);

          case 25:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function checkValidFormObjectsToUse(_x) {
    return _ref.apply(this, arguments);
  };
}();