"use strict";

exports.__esModule = true;
exports.BSFormObjectAddress = BSFormObjectAddress;

var _react = _interopRequireWildcard(require("react"));

var _countryRegionSelector = require("country-region-selector");

var _lodash = require("lodash");

var _style = require("../../utils/style.util");

var _formObject = require("../../utils/form-object.util");

var _others = require("../../utils/others.util");

var _addressStyles = _interopRequireDefault(require("./address.styles.scss"));

var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function BSFormObjectAddress(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? (0, _others.getDefaultView)() : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var customFields = (0, _react.useMemo)(function () {
    return (0, _lodash.get)(object, ["settings", "addressMore", "customFields"]) || {};
  }, [(0, _lodash.get)(object, ["settings", "addressMore", "customFields"])]);

  var _useState = (0, _react.useState)((0, _lodash.get)(object, "type")),
      type = _useState[0];

  var _useState2 = (0, _react.useState)(function () {
    var _addressValue;

    if ((0, _lodash.get)(object, ["settings", "addressMore", "default"])) {
      return (0, _lodash.get)(object, ["settings", "addressMore", "default"]);
    }

    var addressValue = (_addressValue = {}, _addressValue[customFields.addressDetail] = null, _addressValue);
    ((0, _lodash.get)(customFields, ["addressLevels"]) || []).forEach(function (cf) {
      return addressValue[cf] = null;
    });
    return addressValue;
  }),
      address = _useState2[0],
      setAddress = _useState2[1];

  var valid = (0, _react.useMemo)(function () {
    return (0, _formObject.checkValidFormObjectData)(type)(address, object);
  }, [object, (0, _lodash.get)(object, ["settings", "addressMore", "required"]), address]);

  var _useState3 = (0, _react.useState)("vertical"),
      customLayout = _useState3[0];

  var settings = (0, _lodash.get)(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var onChangeAddress = function onChangeAddress(data) {
    setAddress(function (previous) {
      var newAddress = _extends({}, previous);

      ((0, _lodash.get)(customFields, ["addressLevels"]) || []).forEach(function (cf, index) {
        newAddress[cf] = data.value[index] || null;
      });
      return newAddress;
    });
  };

  var onChangeAddressDetail = function onChangeAddressDetail(e) {
    var detail = e.target.value;
    setAddress(function (previous) {
      var _extends2;

      var newAddress = _extends({}, previous, (_extends2 = {}, _extends2[customFields.addressDetail] = detail, _extends2));

      return newAddress;
    });
  };

  (0, _react.useEffect)(function () {
    if (!(0, _lodash.isEmpty)(customFields.addressDetail) && !(0, _lodash.isEmpty)(customFields.addressLevels) && onObjectData) {
      var _addressToSend;

      var addressToSend = (_addressToSend = {}, _addressToSend[customFields.addressDetail] = address[customFields.addressDetail], _addressToSend);

      for (var _iterator = _createForOfIteratorHelperLoose(customFields.addressLevels), _step; !(_step = _iterator()).done;) {
        var cf = _step.value;
        addressToSend[cf] = (0, _lodash.get)(address[cf], "name") || null;
      }

      onObjectData(addressToSend);
    }
  }, [address]);
  (0, _react.useEffect)(function () {
    !(0, _lodash.isEmpty)(customFields.addressDetail) && !(0, _lodash.isEmpty)(customFields.addressLevels) && onValidData && onValidData(_extends({}, valid || {}));
  }, [valid]);

  var addressLevelSelectorStyle = _extends({}, _style.getStyleForSettings["styleGroups"]((0, _lodash.get)(settings, "addressLevelSelector"), view));

  var addressLevelLabelStyle = _extends({}, _style.getStyleForSettings["styleGroups"]((0, _lodash.get)(settings, "addressLevelLabel"), view));

  var addressDetailStyle = _extends({}, _style.getStyleForSettings["styleGroups"]((0, _lodash.get)(settings, "addressDetail"), view));

  return WrapperComponent ? /*#__PURE__*/_react["default"].createElement(WrapperComponent, _extends({
    object: object,
    objectPath: objectPath,
    className: (className || "") + " " + ((0, _lodash.get)(settings, "customClassName") || ""),
    style: _extends({}, _style.getStyleForSettings["styleGroups"]((0, _lodash.pick)(settings, ["padding", "margin"]), view), style || {}, {
      width: "100%"
    })
  }, props), /*#__PURE__*/_react["default"].createElement("input", {
    className: _addressStyles["default"].detail + " " + ((0, _lodash.get)(valid, customFields.addressDetail) ? "" : _addressStyles["default"].inValid),
    placeholder: (0, _lodash.get)(settings, ["addressMore", "placeholders", "addressDetail"]) || "",
    style: addressDetailStyle,
    onChange: onChangeAddressDetail
  }), /*#__PURE__*/_react["default"].createElement(_countryRegionSelector.DynamicLevelLocationSelector, {
    countryCode: (0, _lodash.get)(settings, ["addressMore", "countryCode"]) || "",
    value: ((0, _lodash.get)(settings, ["addressMore", "customFields", "addressLevels"]) || []).map(function (cf) {
      return address[cf] || {
        name: null,
        code: null
      };
    }),
    customLayout: customLayout,
    componentLevels: {
      level0: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[0]
        })
      },
      level1: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[1]
        })
      },
      level2: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[2]
        })
      },
      level3: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[3]
        })
      },
      level4: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[4]
        })
      },
      level5: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[5]
        })
      }
    },
    onChange: onChangeAddress
  })) : /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: (className || "") + " " + ((0, _lodash.get)(settings, "customClassName") || ""),
    style: _extends({}, _style.getStyleForSettings["margin"](settings.margin, view), style || {}, {
      width: "100%"
    })
  }, props), /*#__PURE__*/_react["default"].createElement("input", {
    className: _addressStyles["default"].detail + " " + ((0, _lodash.get)(valid, customFields.addressDetail) ? "" : _addressStyles["default"].inValid),
    style: _extends({}, _style.getStyleForSettings["styleGroups"]((0, _lodash.get)(settings, "addressDetail"), view)),
    onChange: onChangeAddressDetail,
    placeholder: (0, _lodash.get)(settings, ["addressMore", "placeholders", "addressDetail"]) || ""
  }), /*#__PURE__*/_react["default"].createElement(_countryRegionSelector.DynamicLevelLocationSelector, {
    countryCode: (0, _lodash.get)(settings, ["addressMore", "countryCode"]) || "",
    value: ((0, _lodash.get)(settings, ["addressMore", "customFields", "addressLevels"]) || []).map(function (cf) {
      return address[cf] || {
        name: null,
        code: null
      };
    }),
    customLayout: customLayout,
    componentLevels: {
      level0: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[0]
        })
      },
      level1: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[1]
        })
      },
      level2: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[2]
        })
      },
      level3: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[3]
        })
      },
      level4: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[4]
        })
      },
      level5: {
        customLabel: addressLevelLabelStyle,
        customSelector: _extends({}, addressLevelSelectorStyle, {
          placeholder: ((0, _lodash.get)(settings, ["addressMore", "placeholders", "addressLevels"]) || [])[5]
        })
      }
    },
    onChange: onChangeAddress
  }));
}