"use strict";

exports.__esModule = true;
exports.BSFormObjectButton = BSFormObjectButton;

var _lodash = require("lodash");

var _react = _interopRequireWildcard(require("react"));

var _buttonStyles = _interopRequireDefault(require("./button.styles.scss"));

var _others = require("../../utils/others.util");

var _style = require("../../utils/style.util");

var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function BSFormObjectButton(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? (0, _others.getDefaultView)() : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = (0, _react.useState)({}),
      styleFollowingEvents = _useState[0],
      setStyleFollowingEvents = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      actived = _useState2[0],
      setActived = _useState2[1];

  var settings = (0, _lodash.get)(object, "settings") || {};

  var normalStyle = _style.getStyleForSettings["styleGroups"]((0, _lodash.get)(settings, ["buttonStates", "normal"]), view);

  var hoverStyle = _style.getStyleForSettings["styleGroups"]((0, _lodash.get)(settings, ["buttonStates", "hover"]), view);

  var activeStyle = _style.getStyleForSettings["styleGroups"]((0, _lodash.get)(settings, ["buttonStates", "active"]), view);

  var wrapperStyle = _extends({}, _style.getStyleForSettings["styleGroups"]((0, _lodash.pick)(settings, ["padding", "margin", "height", "width", "alignment", "text", "contentAlignment"])), {
    display: "flex",
    alignItems: "center",
    justContent: "center"
  }, style || {});

  var WrapperComponent = wrapperComponent;
  (0, _react.useEffect)(function () {
    setStyleFollowingEvents(normalStyle);
  }, []);
  return WrapperComponent ? /*#__PURE__*/_react["default"].createElement(WrapperComponent, _extends({
    object: object,
    objectPath: objectPath,
    className: _buttonStyles["default"].container + " " + (className || "") + " " + ((0, _lodash.get)(settings, "customClassName") || ""),
    style: _extends({}, wrapperStyle, styleFollowingEvents),
    onMouseEnter: function onMouseEnter() {
      return setStyleFollowingEvents(_extends({}, hoverStyle));
    },
    onMouseLeave: function onMouseLeave() {
      return setStyleFollowingEvents(_extends({}, actived ? activeStyle : normalStyle));
    },
    onClick: onSignalSubmit
  }, props), (0, _lodash.get)(settings, ["buttonMore", "label"])) : /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: _buttonStyles["default"].container + " " + (className || "") + " " + ((0, _lodash.get)(settings, "customClassName") || ""),
    style: _extends({}, wrapperStyle, styleFollowingEvents),
    onMouseEnter: function onMouseEnter() {
      return setStyleFollowingEvents(_extends({}, hoverStyle));
    },
    onMouseLeave: function onMouseLeave() {
      return setStyleFollowingEvents(_extends({}, actived ? activeStyle : normalStyle));
    },
    onClick: onSignalSubmit
  }, props), (0, _lodash.get)(settings, ["buttonMore", "label"]));
}