"use strict";

exports.__esModule = true;
exports.BSFormObjectCell = BSFormObjectCell;

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _cellStyles = _interopRequireDefault(require("./cell.styles.scss"));

var _others = require("../../utils/others.util");

var _style = require("../../utils/style.util");

var _formObjectComponentMappings = require("../../definitions/form-object-component-mappings.definition");

var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function BSFormObjectCell(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? (0, _others.getDefaultView)() : _ref$view,
      object = _ref.object,
      _ref$objectPath = _ref.objectPath,
      objectPath = _ref$objectPath === void 0 ? [] : _ref$objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = (0, _react.useState)({}),
      objectData = _useState[0],
      setObjectData = _useState[1];

  var _useState2 = (0, _react.useState)({}),
      validData = _useState2[0],
      setValidData = _useState2[1];

  var settings = (0, _lodash.get)(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var onChangeObjectData = function onChangeObjectData(data) {
    if (data === void 0) {
      data = {};
    }

    setObjectData(function (previousObjectData) {
      return _extends({}, previousObjectData, data);
    });
  };

  var onChangeValidData = function onChangeValidData(data) {
    if (data === void 0) {
      data = {};
    }

    return setValidData(function (previousObjectData) {
      return _extends({}, previousObjectData, data);
    });
  };

  (0, _react.useEffect)(function () {
    onObjectData && onObjectData(objectData);
  }, [objectData]);
  (0, _react.useEffect)(function () {
    onValidData && onValidData(validData);
  }, [validData]);

  var objectsRender = /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, (object.objects || []).map(function (childObject, index) {
    var FormObjectComponent = _formObjectComponentMappings.FORM_OBJECT_COMPONENT_MAPPINGS[childObject.type];
    return FormObjectComponent ? /*#__PURE__*/_react["default"].createElement(FormObjectComponent, {
      key: childObject.id,
      view: view,
      wrapperComponent: wrapperComponent,
      object: childObject,
      objectPath: [].concat(objectPath, [index]),
      throughProps: throughProps,
      onObjectData: onChangeObjectData,
      onSignalSubmit: onSignalSubmit,
      onValidData: onChangeValidData
    }) : null;
  }));

  var wrapperStyle = _extends({}, _style.getStyleForSettings["styleGroups"](settings, view), settings.contentAlignment ? {
    alignItems: settings.contentAlignment.horizontal,
    justifyContent: settings.contentAlignment.vertical
  } : {}, style || {});

  return wrapperComponent ? /*#__PURE__*/_react["default"].createElement(WrapperComponent, _extends({
    object: object,
    objectPath: objectPath,
    className: _cellStyles["default"].container + " " + (className || "") + " " + ((0, _lodash.get)(settings, ["customClassName"]) || ""),
    style: _extends({}, wrapperStyle)
  }, props), objectsRender) : /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: _cellStyles["default"].container + " " + (className || "") + " " + ((0, _lodash.get)(object, ["settings", "customClassName"]) || ""),
    style: _extends({}, wrapperStyle)
  }, props), objectsRender);
}