"use strict";

exports.__esModule = true;
exports.BsFormObjectImage = BsFormObjectImage;

var _react = _interopRequireDefault(require("react"));

var _lodash = require("lodash");

var _styles = _interopRequireDefault(require("./styles.scss"));

var _others = require("../../utils/others.util");

var _style = require("../../utils/style.util");

var _excluded = ["style", "className", "view", "throughProps", "object", "objectPath", "wrapperComponent", "onObjectData", "onSignalSubmit", "onValidData"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function BsFormObjectImage(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? (0, _others.getDefaultView)() : _ref$view,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      object = _ref.object,
      _ref$objectPath = _ref.objectPath,
      objectPath = _ref$objectPath === void 0 ? [] : _ref$objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var settings = (0, _lodash.get)(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var wrapperStyle = _extends({}, _style.getStyleForSettings["styleGroups"](settings, view), style || {});

  return wrapperComponent ? /*#__PURE__*/_react["default"].createElement(WrapperComponent, _extends({
    className: (className || "") + " " + ((0, _lodash.get)(object, ["settings", "customClassName"]) || ""),
    object: object,
    objectPath: objectPath
  }, props, {
    style: _extends({}, wrapperStyle, {
      overflow: "hidden"
    })
  }), !(0, _lodash.get)(object, ["settings", "image", "url"]) ? /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].imageHolder
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: _styles["default"].icon
  }, /*#__PURE__*/_react["default"].createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "33.325",
    height: "23.65",
    viewBox: "0 0 33.325 23.65"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: "M495.187 312.875v23.65h33.325v-23.65zM526.326 315v12.429l-5.754-5.652-6.968 4.889-6.253-8.556-9.98 7.916V315zm-28.955 19.4v-5.624l9.552-7.576 6.175 8.45 7.236-5.077 5.987 5.885v3.949z",
    style: {
      fill: "#5552d5"
    },
    transform: "translate(-495.187 -312.875)"
  }), /*#__PURE__*/_react["default"].createElement("circle", {
    cx: "2.196",
    cy: "2.196",
    r: "2.196",
    style: {
      fill: "#5552d5"
    },
    transform: "translate(16.953 3.828)"
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].desc
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      color: "#43c0c4"
    }
  }, "+ Upload image"), /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      color: "#999999",
      margin: "0 5px"
    }
  }, "or"), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      color: "#5552d5"
    }
  }, "paste an URL"))) : /*#__PURE__*/_react["default"].createElement("img", {
    src: (0, _lodash.get)(object, ["settings", "image", "url"]),
    style: {
      width: "100%",
      height: "100%"
    }
  })) : /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].container + " " + (className || "") + " " + ((0, _lodash.get)(object, ["settings", "customClassName"]) || ""),
    style: _extends({}, wrapperStyle, {
      display: "block",
      overflow: "hidden"
    })
  }, !(0, _lodash.get)(object, ["settings", "image", "url"]) ? /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].imageHolder,
    style: {
      width: "100%",
      height: "100%"
    }
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: _styles["default"].icon
  }, /*#__PURE__*/_react["default"].createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "33.325",
    height: "23.65",
    viewBox: "0 0 33.325 23.65"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: "M495.187 312.875v23.65h33.325v-23.65zM526.326 315v12.429l-5.754-5.652-6.968 4.889-6.253-8.556-9.98 7.916V315zm-28.955 19.4v-5.624l9.552-7.576 6.175 8.45 7.236-5.077 5.987 5.885v3.949z",
    style: {
      fill: "#5552d5"
    },
    transform: "translate(-495.187 -312.875)"
  }), /*#__PURE__*/_react["default"].createElement("circle", {
    cx: "2.196",
    cy: "2.196",
    r: "2.196",
    style: {
      fill: "#5552d5"
    },
    transform: "translate(16.953 3.828)"
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].desc
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      color: "#43c0c4"
    }
  }, "+ Upload image"), /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      color: "#999999",
      margin: "0 5px"
    }
  }, "or"), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      color: "#5552d5"
    }
  }, "paste an URL"))) : /*#__PURE__*/_react["default"].createElement("img", {
    src: (0, _lodash.get)(object, ["settings", "image", "url"]),
    style: {
      width: "100%",
      height: "100%"
    }
  }));
}