"use strict";

exports.__esModule = true;
exports.BSFormObjectInput = BSFormObjectInput;

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _inputStyles = _interopRequireDefault(require("./input.styles.scss"));

var _formObject = require("../../utils/form-object.util");

var _style = require("../../utils/style.util");

var _excluded = ["style", "className", "view", "object", "objectPath", "wrapperComponent", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function BSFormObjectInput(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? getDefaultView() : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var customField = (0, _react.useMemo)(function () {
    return (0, _lodash.get)(object, ["settings", "customField"]);
  }, [(0, _lodash.get)(object, ["settings", "customField"])]);

  var _useState = (0, _react.useState)((0, _lodash.get)(object, "type")),
      type = _useState[0];

  var _useState2 = (0, _react.useState)((0, _lodash.get)(object, ["settings", "inputMore", "default"]) || ""),
      text = _useState2[0],
      setText = _useState2[1];

  var valid = (0, _react.useMemo)(function () {
    return (0, _formObject.checkValidFormObjectData)(type)(text, object);
  }, [object, (0, _lodash.get)(object, ["settings", "inputMore", "required"]), (0, _lodash.get)(object, ["settings", "inputMore", "inputType"]), text]);
  var settings = (0, _lodash.get)(object, "settings") || {};
  var WrapperComponent = wrapperComponent;

  var onChangeText = function onChangeText(e) {
    var newText = e.target.value;
    setText(newText);
  };

  (0, _react.useEffect)(function () {
    var _onObjectData;

    customField && onObjectData && onObjectData((_onObjectData = {}, _onObjectData[customField] = text, _onObjectData));
  }, [text]);
  (0, _react.useEffect)(function () {
    var _onValidData;

    customField && onValidData && onValidData((_onValidData = {}, _onValidData[customField] = valid, _onValidData));
  }, [valid]);
  return wrapperComponent ? /*#__PURE__*/_react["default"].createElement(WrapperComponent, {
    object: object,
    objectPath: objectPath,
    className: "" + (className || ""),
    style: _extends({}, _style.getStyleForSettings["margin"](settings.margin, view), _style.getStyleForSettings["width"](settings.width, view), (0, _lodash.pick)(style || {}, ["margin", "marginLeft", "marginRight", "marginTop", "marginBottom", "width", "minWidth", "maxWidth"]))
  }, /*#__PURE__*/_react["default"].createElement("input", _extends({
    className: _inputStyles["default"].input + " " + ((0, _lodash.get)(settings, "customClassName") || "") + " " + (!valid ? _inputStyles["default"].validError : ""),
    type: (0, _lodash.get)(settings, ["inputMore", "inputType"]),
    name: (0, _lodash.get)(settings, ["customField"]),
    placeholder: (0, _lodash.get)(settings, ["inputMore", "placeholder"]) || "",
    value: text,
    onChange: onChangeText,
    style: _extends({}, _style.getStyleForSettings["styleGroups"]((0, _lodash.omit)(settings, ["width", "margin"]), view), {
      width: "100%"
    }, (0, _lodash.omit)(style || {}, ["margin", "marginLeft", "marginRight", "marginTop", "marginBottom", "width", "minWidth", "maxWidth"]))
  }, props))) : /*#__PURE__*/_react["default"].createElement("input", _extends({
    className: _inputStyles["default"].input + " " + (className || "") + " " + ((0, _lodash.get)(settings, "customClassName") || "") + " " + (!valid ? _inputStyles["default"].validError : ""),
    type: (0, _lodash.get)(settings, ["inputMore", "inputType"]),
    name: (0, _lodash.get)(settings, ["customField"]),
    placeholder: (0, _lodash.get)(settings, ["inputMore", "placeholder"]) || "",
    value: text,
    onChange: onChangeText,
    style: _extends({}, _style.getStyleForSettings["styleGroups"](settings, view), style || {})
  }, props));
}