"use strict";

exports.__esModule = true;
exports.BSFormObjectLabel = BSFormObjectLabel;

var _react = _interopRequireDefault(require("react"));

var _lodash = require("lodash");

var _labelStyles = _interopRequireDefault(require("./label.styles.scss"));

var _others = require("../../utils/others.util");

var _style = require("../../utils/style.util");

var _excluded = ["style", "className", "view", "wrapperComponent", "object", "objectPath", "throughProps", "onObjectData", "onSignalSubmit", "onValidData"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function BSFormObjectLabel(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? (0, _others.getDefaultView)() : _ref$view,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var settings = object.settings || {};
  var WrapperComponent = wrapperComponent;

  var wrapperStyle = _extends({}, _style.getStyleForSettings["styleGroups"](settings, view), style || {});

  return WrapperComponent ? /*#__PURE__*/_react["default"].createElement(WrapperComponent, _extends({
    object: object,
    objectPath: objectPath,
    className: _labelStyles["default"].container + " " + (className || "") + " " + ((0, _lodash.get)(settings, "customClassName") || ""),
    style: _extends({
      width: "100%"
    }, wrapperStyle)
  }, props), (0, _lodash.get)(settings, ["labelMore", "label"]) || "") : /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: _labelStyles["default"].container + " " + (className || "") + " " + ((0, _lodash.get)(settings, "customClassName") || ""),
    style: wrapperStyle
  }, props), (0, _lodash.get)(settings, ["labelMore", "label"]) || "");
}