"use strict";

exports.__esModule = true;
exports.BSFormObjectRadio = BSFormObjectRadio;

require("antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("antd/lib/radio"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _formObject = require("../../utils/form-object.util");

var _style = require("../../utils/style.util");

var _excluded = ["style", "className", "view", "object", "objectPath", "throughProps", "wrapperComponent", "onObjectData", "onClick", "onSignalSubmit", "onValidData"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function BSFormObjectRadio(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$view = _ref.view,
      view = _ref$view === void 0 ? getDefaultView() : _ref$view,
      object = _ref.object,
      objectPath = _ref.objectPath,
      _ref$throughProps = _ref.throughProps,
      throughProps = _ref$throughProps === void 0 ? {} : _ref$throughProps,
      _ref$wrapperComponent = _ref.wrapperComponent,
      wrapperComponent = _ref$wrapperComponent === void 0 ? null : _ref$wrapperComponent,
      _ref$onObjectData = _ref.onObjectData,
      onObjectData = _ref$onObjectData === void 0 ? null : _ref$onObjectData,
      _ref$onClick = _ref.onClick,
      _onClick = _ref$onClick === void 0 ? null : _ref$onClick,
      _ref$onSignalSubmit = _ref.onSignalSubmit,
      onSignalSubmit = _ref$onSignalSubmit === void 0 ? null : _ref$onSignalSubmit,
      _ref$onValidData = _ref.onValidData,
      onValidData = _ref$onValidData === void 0 ? null : _ref$onValidData,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var customField = (0, _react.useMemo)(function () {
    return (0, _lodash.get)(object, ["settings", "customField"]);
  }, [(0, _lodash.get)(object, ["settings", "customField"])]);

  var _useState = (0, _react.useState)((0, _lodash.get)(object, "type")),
      type = _useState[0];

  var _useState2 = (0, _react.useState)((0, _lodash.get)(object, ["settings", "radioMore", "default"]) || false),
      checked = _useState2[0],
      setChecked = _useState2[1];

  var valid = (0, _react.useMemo)(function () {
    return (0, _formObject.checkValidFormObjectData)(type)((0, _lodash.get)(object, ["settings", "radioMore", "default"]), object);
  }, [object, (0, _lodash.get)(object, ["settings", "radioMore", "required"]), checked]);
  var settings = object.settings || {};
  var WrapperComponent = wrapperComponent;

  var onChangeChecked = function onChangeChecked() {
    setChecked(true);
    setValid((0, _formObject.checkValidFormObjectData)(type)(true, object));
  };

  (0, _react.useEffect)(function () {
    var _onObjectData;

    customField && onObjectData && onObjectData((_onObjectData = {}, _onObjectData[customField] = checked, _onObjectData));
  }, [checked]);
  (0, _react.useEffect)(function () {
    var _onValidData;

    customField && onValidData && onValidData((_onValidData = {}, _onValidData[customField] = valid, _onValidData));
  }, [valid]);
  return WrapperComponent ? /*#__PURE__*/_react["default"].createElement(WrapperComponent, {
    object: object,
    objectPath: objectPath,
    className: "" + (className || ""),
    style: _extends({}, _style.getStyleForSettings["styleGroups"]((0, _lodash.pick)(settings, ["margin", "alignment"]), view), {
      width: "auto"
    }, (0, _lodash.pick)(style || {}, ["margin", "marginLeft", "marginRight", "marginTop", "marginBottom"]))
  }, /*#__PURE__*/_react["default"].createElement(_radio["default"], _extends({
    className: "" + ((0, _lodash.get)(settings, ["customClassName"]) || ""),
    style: _extends({}, _style.getStyleForSettings["text"](settings.text, view), (0, _lodash.omit)(style || {}, ["margin", "marginLeft", "marginRight", "marginTop", "marginBottom"])),
    checked: checked,
    onClick: function onClick(e) {
      onChangeChecked(e);
      _onClick && _onClick(e);
    }
  }, props), (0, _lodash.get)(settings, ["radioMore", "label"]))) : /*#__PURE__*/_react["default"].createElement(_radio["default"], _extends({
    className: ((0, _lodash.get)(settings, ["customClassName"]) || "") + " " + (className || ""),
    style: _extends({}, _style.getStyleForSettings["styleGroups"](settings, view), style || {}),
    checked: checked,
    onClick: function onClick(e) {
      onChangeChecked(e);
      _onClick && _onClick(e);
    }
  }, props), (0, _lodash.get)(settings, ["radioMore", "label"]));
}