"use strict";

exports.__esModule = true;
exports.getDefaultView = exports.detectBrowser = void 0;

var _lodash = require("lodash");

var _browsers = require("../definitions/browsers.definition");

var detectBrowser = function detectBrowser() {
  var userAgent = typeof window === "undefined" ? "" : (0, _lodash.get)(window, ["navigator", "userAgent"]) || "";
  return userAgent.indexOf("Firefox") > -1 ? _browsers.BROWSERS.FIREFOX : userAgent.indexOf("Chrome") > -1 ? _browsers.BROWSERS.CHROME : userAgent.indexOf("Safari") ? _browsers.BROWSERS.SAFARI : _browsers.BROWSERS.UNKNOWN;
};

exports.detectBrowser = detectBrowser;

var getDefaultView = function getDefaultView() {
  return {
    width: typeof window === "undefined" ? 0 : (0, _lodash.get)(window, ["innerWidth"]) || 0,
    height: typeof window === "undefined" ? 0 : (0, _lodash.get)(window, ["innerHeight"]) || 0
  };
};

exports.getDefaultView = getDefaultView;